	var requestURI = window.location.pathname.substr(1).split("/");
//	alert(requestURI[1]);

	var mapWidth=256;
	var mapHeight=256;
	
	var world = requestURI[1];
	
	var mapX = 0;
	var mapZ = 0;
	
	var nowScrollMap = false;
	var scrollStartX = 0;
	var scrollStartY = 0;
	
	var cursorX = 0;
	var cursorZ = 0;
	
	var olderMapX = null;
	var olderMapZ = null;
	
	var loadedMaps = new Object();
	
	var mapZeroLocation = null;
	var webSocket = null;
	
	var entities = new Array();
	
	var touchMove = false;
	var moveCancel = false;
	var useragent = navigator.userAgent.toLowerCase();
	
	var followPlayer = "";
	
	if(useragent.indexOf('iphone') > 0 || useragent.indexOf('android') > 0){
		touchMove = confirm('Mobile Mode ?');
	}
	
	
	function $get(id){return document.getElementById(id);}
	
	window.onload = function(){
		for(var x = 0;x<getBrowserHeight()+mapWidth;x+= mapWidth){
			for(var z = 0;z<getBrowserHeight()+mapHeight;z+= mapHeight){
				var mx = x / mapWidth;
				var mz = z / mapHeight;
				loadMap(mx,mz);
			}
		}

		var inside = $get('mapinside');
		inside.style.left = 0;
		inside.style.top = 0;

		getEntities();
		moveTo(0,0);
	}
	
	function moveTo(x,y){
		x += getBrowserWidth()/2;
		y += getBrowserHeight()/2;
		$('#mapinside').animate({
				'left': x + 'px',
				'top': y + 'px',
			},{
				'duration': 700,
				'easing': 'swing',
				'complete': function(){loadWithMapPosition();},
				'step': function(s){loadWithMapPosition();}
			});
	}
	
	window.document.ontouchmove = function(e){
		cursorX = getMouse(e).x;
		cursorY = getMouse(e).y;
	}
	 
	window.document.onmousemove = function(e){
		cursorX = getMouse(e).x;
		cursorY = getMouse(e).y;
	}
	
	
	
    function getMouse(e) {
	    var obj = new Object();
		if(e) {
			obj.x = e.pageX;
			obj.y = e.pageY;
		}else{
			obj.x = event.x + document.body.scrollLeft;
			obj.y = event.y + document.body.scrollTop;
		}
		return obj;
    }

	function getBrowserWidth() {
        if ( window.innerWidth ) {
                return window.innerWidth;
        }
        else if ( document.documentElement && document.documentElement.clientWidth != 0 ) {
                return document.documentElement.clientWidth;
        }
        else if ( document.body ) {
                return document.body.clientWidth;
        }
        return 0;
	}
	
	function getBrowserHeight() {
        if ( window.innerHeight ) {
                return window.innerHeight;
        }
        else if ( document.documentElement && document.documentElement.clientHeight != 0 ) {
                return document.documentElement.clientHeight;
        }
        else if ( document.body ) {
                return document.body.clientHeight;
        }
        return 0;
	}
	
	function loadMap(x,z){
		if(loadedMaps[x + "," + z] == 1){return;}
		debug("Map Load !!");
			loadedMaps[x + "," + z] = 1;
		var fileName = world + "/big/" + x + "_" + z + ".png?" + (new Date()).getTime();
		var map = $get('mapinside');
		var currentMapX = map.style.left;
		var currentMapY = map.style.top;
		
		var sax = 0;
		var saz = 0;
		
		
		
		var img = document.createElement("div");
//			img.src = fileName;
			img.onclick = function(){return false;}
			img.style.position = "absolute";
			img.style.left = (x * mapWidth + sax) + "px";
			img.style.top = (z * mapHeight + saz) + "px";
			
			debug("Add:" + img.style.left + " x " + img.style.top + " [" + x + ":" + z + "] " + fileName + " : " + img.style.left + " x " + img.style.top);
			img.style.width = mapWidth + "px";
			img.style.height = mapHeight + "px";
			
			img.style.backgroundColor = "#000";
			//img.style.border = "1px inset red";
			
			img.style.backgroundImage = "url('" + fileName + "')";
			img.setAttribute("onclick","this.style.backgroundImage='url("+fileName+"?'+(new Date()).getTime()+')'");
			img.style.zIndex = 1;
			map.appendChild(img);
			
		var text = document.createElement("strong");
			text.innerHTML = "(" + (x * mapWidth) + "," + (z*mapHeight) + ")";
			img.appendChild(text);
			img.style.fontSize = "10px";
			if(touchMove){
				img.setAttribute("ontouchstart","moveCancel=false;");
				img.setAttribute("ontouchmove","moveCancel=true;");
				img.setAttribute("ontouchend","if(!moveCancel){moveTo(" + -x * 256 + "," + -z * 256 + ");}");
			}
			return img;
	}
	
	function scrollStart(){
		nowScrollMap = true;
		scrollStartX = cursorX;
		scrollStartY = cursorY;
	}
	
	function scrollStop(){
		nowScrollMap = false;
	}
	
	function touchScroll(e){
		alert(e);
	}
	
	function scrolling(){
		if(!nowScrollMap || touchMove){return;}
		var sax = scrollStartX - cursorX;
		var say = scrollStartY - cursorY;
		
		scrollStartX = cursorX;
		scrollStartY = cursorY;
		
		var map = $get('map');
		var inside = $get('mapinside');
		var insX = inside.style.left || 0;
		var insZ = inside.style.top || 0;
		inside.style.left = parseInt(insX) - sax;
		inside.style.top = parseInt(insZ) - say;

		loadWithMapPosition();
	}
	
	function loadWithMapPosition(){
		var inside = $get('mapinside');
		
		var currentMapX = parseInt(inside.style.left);
		var currentMapY = parseInt(inside.style.top);
		var loadX2 = -Math.round((currentMapX-getBrowserWidth()) / mapWidth);
		var loadY2 = -Math.round((currentMapY-getBrowserHeight()) / mapHeight);
		var loadX1 = -Math.round((currentMapX+getBrowserWidth()) / mapWidth);
		var loadY1 = -Math.round((currentMapY+getBrowserHeight()) / mapHeight);
		debug("MAPLOAD:" + loadX1 + "-" + loadX2 + " , " + loadY1 + "-" + loadY2);
		for(var x = loadX1;x < loadX2;x++){
			for(var z = loadY1;z < loadY2;z++){
				loadMap(x,z);
			}
		}
	}
	
	
	function getEntities(){
		var xhr = new XMLHttpRequest();
		xhr.open('GET', '/entities/' + world, true);
		xhr.overrideMimeType('text/plain;');
		xhr.onreadystatechange = function(e) {
			if (this.readyState == 4 && this.status == 200) {
				var entData = this.responseText;
				var ents = eval(entData);
				var map = $get('mapinside');
				var entitiesTemp = entities;
				entities = new Array();
				var num = 0;
				var plist = $get("playerListSelector");
				plist.innerHTML = "<option value=\"\">No Follow</option>";
				for(var key in ents["player"]){
						var player = ents["player"][key];
						var pos = player.POS.split("\t");
						var img = document.createElement("span");
							img.style.position = "absolute";
							img.style.backgroundImage = "url('/icon/Player?n="+key+"')";
							img.style.height = "8px";
							img.style.left = pos[1];
							img.style.top = pos[3];
							img.style.zIndex = 20000;
							img.style.fontSize = "10px";
							img.style.fontWeight = "100";
							img.style.color = "white";
							img.style.backgroundRepeat = "no-repeat";
							img.style.paddingLeft = "10px";
							img.setAttribute("locX",pos[1]);
							img.setAttribute("locY",pos[2]);
							img.setAttribute("locZ",pos[3]);
							
							for(var k in player){
								img.setAttribute(k,player[k]);
							}
							img.innerHTML = key;
							entities.push(img);
							map.appendChild(img);
							img.setAttribute("onClick","entityInfo(this);");
							
						var option = document.createElement("option");
							option.setAttribute("value",key);
							option.innerHTML = key;
							option.style.backgroundImage = "url('/icon/Player?n=" + key + "')";
							if(followPlayer == key){
								$get('mapinside').style.left = (-pos[1] + getBrowserWidth()/2) + "px";
								$get('mapinside').style.top = (-pos[3] + getBrowserHeight()/2) + "px";
								option.selected = true;
							}
							plist.appendChild(option);
				}
				
				
				
				
				for(var key in ents){
					if(key == "player" || key == "status"){continue;}
					var ary = ents[key];
					
					for(var i = 0; i < ary.length ; i++){
					num++;
						var ent = ary[i];
						var pos = ent.POS.split("\t");
						var img = document.createElement("span");
							img.style.position = "absolute";
							img.style.backgroundImage = "url('/icon/"+key+"')";
							img.style.width = "8px";
							img.style.height = "8px";
							img.style.left = pos[1];
							img.style.top = pos[3];
							img.style.zIndex = 10000;
							if(key == "Sheep"){
								img.style.border = "1px solid " + ent.COL;
							}else{
								img.style.border = "1px solid black";
							}
							img.style.cursor = "pointer";
							img.setAttribute("locX",pos[1]);
							img.setAttribute("locY",pos[2]);
							img.setAttribute("locZ",pos[3]);
							img.setAttribute("entityType",key);
							
							for(var k in ent){
								img.setAttribute(k,ent[k]);
							}
							
							img.setAttribute("onMouseOver","entityInfo(this);");
							img.setAttribute("ondblclick","entityInfo(null);");
//							img.setAttribute("onMouseOut","entityInfo(null);");
							
							
							entities.push(img);
							map.appendChild(img);
							
					}
				}
				for(var node in entitiesTemp){
					map.removeChild(entitiesTemp[node]);
				}
				
				setTimeout("getEntities()",5000);
			}else{
				if(this.readyState == 4 && this.status == 0){
					setTimeout("getEntities()",10000);
				}
			}
		};
		xhr.send();
	}
	
	function entityInfo(entity){
		if(entity == null){
			$get('status').innerHTML = "";
			$("#status").animate({
            	height: 0
        	}, 200);
		}else{
			var atr = new Object();
			
			for (var i=0, attrs=entity.attributes, l=attrs.length; i<l; i++){
				atr[attrs.item(i).nodeName]=entity.getAttribute(attrs.item(i).nodeName);
			}
			
			if(parseInt($get("status").style.height) <= 10 || $get("status").style.height == 0){
				$("#status").animate({
					height: 300
				}, 200);
			}else{
			}
			
			
			$get('status').innerHTML = "" +
			"<h3>" + atr.entitytype + "</h3>" +
			"<p>POS:" + parseInt(atr.locx*100)/100 + " , " + parseInt(atr.locy*100)/100 + " , " + parseInt(atr.locz*100)/100 + "</p>"+
			"";
			// "
			if(atr.entitytype == "Item"){
				$get('status').innerHTML += "<p>ItemType : " + entity.getAttribute("MATERIAL") + "<br />"+
				"Amount : " + atr.amount + "<br />" +
				"Damage : " + atr.damage + "</p>";
			}

		}
	}
	
	function debug(s){
		return;
		$get("debug").innerHTML = s + "<br />" + $get("debug").innerHTML;
	}
	
	
	
	
